
/************************ Adafruit IO Configuration *******************************/

// visit io.adafruit.com if you need to create an account,
// or if you need your Adafruit IO key.
#define IO_USERNAME  "xx"
#define IO_KEY       "xx"

/******************************* WIFI Configuration **************************************/

#define WIFI_SSID       "xx"
#define WIFI_PASS       "xx"

#include "AdafruitIO_WiFi.h"
AdafruitIO_WiFi io(IO_USERNAME, IO_KEY, WIFI_SSID, WIFI_PASS);

/************************ Main Program Starts Here *******************************/
#include <ESP8266WiFi.h>
#include <AdafruitIO.h>
#include <Adafruit_MQTT.h>
#include <ArduinoHttpClient.h>


#include <AdafruitIO_WiFi.h>
#include "Adafruit_Thermal.h"


#include "SoftwareSerial.h"
#define TX_PIN 6 // Arduino transmit  YELLOW WIRE  labeled RX on printer
#define RX_PIN 5 // Arduino receive   GREEN WIRE   labeled TX on printer

// Pin for the button
#define BUTTON_PIN 4

// Define the feed
AdafruitIO_Feed *textFaxFeed = io.feed("Text-Fax");

// Variable to track button state
int buttonState = 0;


// Variable to store the last received message
String lastReceivedMessage = "";


void setup() {
  
  pinMode(7, OUTPUT); digitalWrite(7, LOW);

  // Set button pin as input
  pinMode(BUTTON_PIN, INPUT_PULLUP);

  // Start the serial communication
  Serial.begin(115200);

  // Wait for a connection
  Serial.println("Connecting to Adafruit IO...");
  // Connect to Adafruit IO
  io.connect();

  // Subscribe to the "Text-Fax" feed
  textFaxFeed->onMessage(receiveMessage);

  printer.begin();        // Init printer (same regardless of serial type)

  // The following calls are in setup(), but don't *need* to be.  Use them
  // anywhere!  They're just here so they run one time and are not printed
  // over and over (which would happen if they were in loop() instead).
  // Some functions will feed a line when called, this is normal.

}

void loop() {
  // Ensure the connection to Adafruit IO is maintained
  io.run();

  // Read the state of the button
  buttonState = digitalRead(BUTTON_PIN);

  //Serial.println(buttonState);

  // Check if the button is pressed
  if (buttonState == LOW) {
    // Button is pressed, print the last received message
    printer.setSize('M');
    printer.println(F("New Message:"));
    printer.println(F(lastReceivedMessage));
    printer.println(F("#unplugged"));
    //Serial.print("New Message: ");
    //Serial.println(lastReceivedMessage);
    //Serial.print("#unplugged \n");
  }

}


void receiveMessage(AdafruitIO_Data *data) {
  // Update the last received message
  lastReceivedMessage = data->toString();
  
}